
/*
XMail OSAX -- Copyright (C) 2004 Jean-Baptiste LE STANG jb.lestang@libertysurf.fr

	
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#include <Carbon/Carbon.h>
#include "Terminology.h"
#include "mail.h"
#include "smtp.h"



OSStatus	XM_MakeErrorReply( AppleEvent *theReply, const OSErr theErrorCode,char * theMessage );
OSStatus	XM_GetDescString( const AEDesc *theDesc, std::string & theString );
OSStatus	XM_GetTextParamAsString( const AppleEvent *theEvent, const AEKeyword theKeyword, std::string & theField );
OSStatus	XM_GetUnicodeParamAsString( const AppleEvent *theEvent, const AEKeyword theKeyword, const TextEncoding toEncoding, std::string & theField );
OSStatus	XM_GetListItemAsString( const AEDescList *theList, const DescType theType, const SInt32 theIndex, std::string & theField );
OSStatus	XM_GetParamListItemAsString( const AppleEvent *theEvent, const AEKeyword theKeyword, const DescType theType, const SInt32 theIndex, std::string & theField );
OSStatus	XM_DoRecipients( const AppleEvent *theEvent, const AEKeyword theKeyword, mail_t * mail, recipient theRecipientKind );
OSStatus	XM_DoAttachments( const AppleEvent *theEvent,mail_t * mail) ;
OSStatus	XM_DoPriority( const AppleEvent *theEvent,mail_t * mail);
OSStatus	XM_DoExtraHeaders( const AppleEvent *theEvent,mail_t * mail);
OSStatus	XM_DoGetSASL(const AppleEvent * theEvent, std::string & theSASL);
OSStatus	XM_DoGetSSL(const AppleEvent * theEvent, ssl_type_t * theSSL, ssl_opts_t * option);
OSStatus	XM_DoGetSSLCertificates(const AppleEvent * theEvent,std::string & ca_path, std::string & ca_dir);
OSStatus	XM_DoGetPort(const AppleEvent * theEvent, long * thePort);
OSStatus	XM_DoGetTimeout(const AppleEvent * theEvent, long  * theTimeout);
OSStatus	XM_GenerateToList(const AppleEvent * theEvent, char ** theList);
int			XM_GetToRecipientsCount(const AppleEvent * theEvent);
int			XM_GetBodySize( const AppleEvent * theEvent);

OSStatus sendMail( const AppleEvent *theEvent, AppleEvent *theReply, long theRefCon );
OSStatus sendMailRaw( const AppleEvent *theEvent, AppleEvent *theReply, long theRefCon );
